from scapy.all import *
#from scapy.layers.dot11 import Dot11, Dot11Beacon, RadioTap, sendp, Dot11Elt
# from scapy.all import hexdump  # Used in commented code so uncomment when you uncomment the code
from uuid import getnode as get_mac
import os
import sys
import psutil

# The following is used to ensure that there is no issues with finding any local packages.
# Mainly used for accessing python-nan once upon a time but could still be useful now.
file_dir = os.path.dirname(__file__)
sys.path.append(file_dir)
sys.path.append(os.path.join(os.path.dirname(__file__), '..'))
sys.path.append(os.path.join(os.path.dirname(__file__), '../..'))


iface = 'Wi-Fi'  # This is the wifi interface on the drone, Wi-Fi seems to be a common windows name
# while linux seems to use wlan0 so the following checks if wlan0 is an interface then switches to that in that case.
iface = 'wlp2s0'
addrs = psutil.net_if_addrs()
if "wlan0" in addrs.keys():
    iface = "wlan0"


def beacon_wifi(mac_address,  element_info):
    """
    Broadcasts a wifi beacon from mac_address with the SSID as the given element_info.
    :param mac_address: A array of integer values representing the devices mac_address
    :param element_info: The info needed sent
    :return: None
    """
    dot11 = Dot11(type=0, subtype=8, addr1='ff:ff:ff:ff:ff:ff',
                  addr2=mac_address, addr3=mac_address)

    dot_11_beacon = Dot11Beacon()
    # Beacon that claims it needs a password for access
    # dot_11_beacon = Dot11Beacon(cap='ESS+privacy')

    # Actual information that should be sent
    dot_11_element = Dot11Elt(ID='SSID', info=element_info, len=len(element_info))
    # Test to ensure easy debug
    # dot_11_element = Dot11Elt(ID='SSID', info='fakeTestNetwork', len=len('fakeTestNetwork'))

    frame = RadioTap()/dot11 / dot_11_beacon / dot_11_element
    # Following block adds fake security to the access point when detected so it will say on other devices
    # that it needs a password.
    # rsn = Dot11Elt(ID='RSNinfo', info=(
    #    '\x01\x00'
    #    '\x00\x0f\xac\x02'
    #    '\x02\x00'
    #    '\x00\x0f\xac\x04'
    #    '\x00\x0f\xac\x02'
    #    '\x01\x00'
    #    '\x00\x0f\xac\x02'
    #    '\x00\x00'))
    # frame = RadioTap()/dot11/dot_11_beacon/ dot_11_element /rsn

    frame.show()  # Prints a readable version of the frame that is being sent

    # hexdump(frame)  # Prints a hexdump of the frame that is being sent.

    sendp(frame, iface=iface, inter=0.100, loop=1)  # send the packet over interface iface every 100 milliseconds


mac = hex(get_mac())  # fetches device mac address
mac_arr = list(bytearray.fromhex(mac[2:]))  # converts it into int

#print(mac)
#print(mac_arr)

#vendor_info = '130042200100250B3FA14C1CEE522E25ADD5B000000000000000'  # Static message to send
#beacon_wifi(mac_arr, vendor_info)  # Actual call to the method
